const dayjs = require("dayjs");

module.exports = {
  // 檢測物件、矩陣是否為空
  isEmpty: function (val) {
    if (Array.isArray(val) && val.length === 0)
      return true;

    if (JSON.stringify(val) === "{}")
      return true;

    return false;
  },

  formatStamp: function (timestamp, format = "YYYY-MM-DD HH:mm:ss") {
    return dayjs(timestamp * 1000).format(format)
  },

  getNow: function (format = "YYYY-MM-DD HH:mm:ss") {
    return dayjs().format(format)
  },

  getUnix: function (offset = 0) {
    return parseInt(new Date() / 1000) + offset
  },

  // 在左邊補值
  padLeft: function (str, lenght, filler = "0") {
    str += "";

    if (str.length >= lenght)
      return str;
    else
      return this.padLeft(filler + str, lenght, filler);
  },

  // 包裝 promise，使用 Golang 風格返回錯誤
  to: function (promise) {
    return promise.then(data => [null, data])
      .catch(err => [err]);
  }
}